package com.fp.persistence.parmas.ins;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMPLANIFICACIONTRAMITE*/
@Entity(name="TarmPlanificacionTramite")
@Table(name="TARMPLANIFICACIONTRAMITE")
public class TarmPlanificacionTramite extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmPlanificacionTramite
*/
@Id
@Column(name="CPLANIFICACIONTRAMITE" ,nullable=false, updatable=false)
private Long pk;
@Column(name="CTRAMITE", nullable=true)

/**
* null
*/
private Long ctramite;

@Column(name="MESNUMERO", nullable=true)

/**
* null
*/
private Long mesnumero;

@Column(name="CPLANIFICACION", nullable=true)

/**
* null
*/
private Long cplanificacion;

@Column(name="INSPECCION", nullable=true)

/**
* null
*/
private String inspeccion;

@Column(name="CSOLICITUD", nullable=true)

/**
* null
*/
private String csolicitud;

@Column(name="CDOCUMENTO", nullable=true)

/**
* null
*/
private Long cdocumento;

@Column(name="MES", nullable=true)

/**
* null
*/
private String mes;

@Column(name="PERIODO", nullable=true)

/**
* null
*/
private String periodo;

@Column(name="INSPECTORES", nullable=true)

/**
* null
*/
private Long inspectores;

@Column(name="VEHICULOS", nullable=true)

/**
* null
*/
private Long vehiculos;

@Column(name="PRESUPESTO", nullable=true)

/**
* null
*/
private Float presupuesto;

/**Contructor por defecto*/
public TarmPlanificacionTramite(){
}
/**Contructor de TarmPlanificacionTramite
@param pPk Clave Primaria del entity
*/
public TarmPlanificacionTramite(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmPlanificacionTramite
*/
public static TarmPlanificacionTramite find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmPlanificacionTramite obj = pEntityManager.find(TarmPlanificacionTramite.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmPlanificacionTramite
@return El objeto que referencia a la Clave primaria de TarmPlanificacionTramite
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmPlanificacionTramite
@param pPk El objeto que referencia a la nueva Clave primaria de TarmPlanificacionTramite
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de ctramite
@return valor de ctramite*/
public Long getCtramite(){
  return ctramite;
}
/**Fija el valor de ctramite
@param pCtramite nuevo Valor de ctramite*/
public void setCtramite(Long pCtramite){
  ctramite=pCtramite;
}

/**Obtiene el valor de mesnumero
@return valor de mesnumero*/
public Long getMesnumero(){
  return mesnumero;
}
/**Fija el valor de mesnumero
@param pMesnumero nuevo Valor de mesnumero*/
public void setMesnumero(Long pMesnumero){
  mesnumero=pMesnumero;
}

/**Obtiene el valor de cplanificacion
@return valor de cplanificacion*/
public Long getCplanificacion(){
  return cplanificacion;
}
/**Fija el valor de cplanificacion
@param pCplanificacion nuevo Valor de cplanificacion*/
public void setCplanificacion(Long pCplanificacion){
  cplanificacion=pCplanificacion;
}

/**Obtiene el valor de inspeccion
@return valor de inspeccion*/
public String getInspeccion(){
  return inspeccion;
}
/**Fija el valor de inspeccion
@param pInspeccion nuevo Valor de inspeccion*/
public void setInspeccion(String pInspeccion){
  inspeccion=pInspeccion;
}

/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Obtiene el valor de cdocumento
@return valor de cdocumento*/
public Long getCdocumento(){
  return cdocumento;
}
/**Fija el valor de cdocumento
@param pCdocumento nuevo Valor de cdocumento*/
public void setCdocumento(Long pCdocumento){
  cdocumento=pCdocumento;
}

/**Obtiene el valor de mes
@return valor de mes*/
public String getMes(){
  return mes;
}
/**Fija el valor de mes
@param pMes nuevo Valor de mes*/
public void setMes(String pMes){
  mes=pMes;
}

/**Fija el valor de mes
@param pMes nuevo Valor de periodo*/
public void setPeriodo(String pPeridodo){
	periodo=pPeridodo;
}

/**Obtiene el valor de periodo
@return valor de mes*/
public String getPeriodo(){
  return periodo;
}

/**Obtiene el valor de inspectores
@return valor de inspectores*/
public Long getInspectores(){
  return inspectores;
}
/**Fija el valor de cdocumento
@param pCdocumento nuevo Valor de cdocumento*/
public void setInspectores(Long pinspectores){
	inspectores=pinspectores;
}

/**Obtiene el valor de vehiculos
@return valor de vehiculos*/
public Long getVehiculos(){
  return vehiculos;
}
/**Fija el valor de cdocumento
@param pCdocumento nuevo Valor de cdocumento*/
public void setVehiculos(Long pvehiculos){
	vehiculos=pvehiculos;
}

/**Obtiene el valor de presupuesto I
@return valor de presupuesto I*/
public Float getPresupuesto() {
	return presupuesto;
}
/**Fija el valor de presupuesto I
@param pidPlanificacion nuevo Valor de presupuesto I*/
public void setPresupuesto(Float ppresupuesto) {
	this.presupuesto = ppresupuesto;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmPlanificacionTramite))return false;
    TarmPlanificacionTramite that = (TarmPlanificacionTramite) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmPlanificacionTramite
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmPlanificacionTramite
*/
public Object createInstance(){
 TarmPlanificacionTramite instance=new TarmPlanificacionTramite();	
 return instance;
}
/**Clona la entidad TarmPlanificacionTramite
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmPlanificacionTramite p=(TarmPlanificacionTramite)this.clone();
  return p;
}
}
